﻿Public Class Form1
    Dim a$, f$, count

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        SerialPort1.Close()

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        SerialPort1.Open()
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If CheckBox1.Checked Then
            SerialPort1.Write("m")
        Else
            SerialPort1.Write("u")
        End If
    End Sub

    Private Sub CheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckedChanged
        If CheckBox2.Checked Then
            SerialPort1.Write("1")
        Else
            SerialPort1.Write("3")
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim snr, pid, af, rssi, No$ ' HAUPTSCHLEIFE 
        No$ = "No RDS"
        SerialPort1.Write("f") 'Frequenz 
        f$ = SerialPort1.ReadLine
        SerialPort1.Write("0") 'RSSI/SNR
        Label1.Text = SerialPort1.ReadLine
        snr = Val(Mid$(Label1.Text, 4, 2))
        Anal(snr, 50) ' Test
        rssi = Val(Mid$(Label1.Text, 1, 2))
        If rssi > 50 Then rssi = 50
        ProgressBar1.Value = 10 + 2 * rssi ' magisches Band
        ProgressBar2.Value = 10 + 2 * rssi
        If snr > 11 And RadioButtonFM.Checked Then 'RDS kommt
            SerialPort1.Write("r") 'RDS
            a$ = SerialPort1.ReadLine ' Langer String
            pid = Mid$(a$, 1, 4) 'Testrückgabe für AF
            Me.Text = " PID: " + Mid$(a$, 1, 4) 'PID im Titel
            Label2.Text = RTrim(Mid$(a$, 5, 8)) 'SENDERNAME
            LabelTime.Text = Mid$(a$, 19, 5) 'TIMELOCAL
            LabelDate.Text = Mid$(a$, 24, 10) 'DATE
            TextBox1.Text = LTrim(Mid$(a$, 34, 64)) 'RADIOTEXT
            Label3.Text = f$ ' Frequenz
            'Alternative Frequenzen wie sie kommen
            af = Val("&h" + Mid$(pid, 3, 2))
            If af > 0 And af < 205 Then
                count = count + 1 ' Ruhigere Anzeige
                a$ = "AF: " + Format((8750 + 10 * af) / 100, "#00.0")
                If count Mod 5 = 0 Then LabelAF.Text = a$
            End If
        Else 'Kein RDS/Schwaches Signal
            Me.Text = " Arduino goes Radio"
            Label2.Text = f$ 'Frequenz
            Label3.Text = No$ : LabelAF.Text = No$
            LabelTime.Text = No$ : LabelDate.Text = No$
            TextBox1.Text = " Happy DXing!"
        End If
        'Startup: Timerintervall 3000, FM not checked
        If Timer1.Interval <> 250 Then 'Startverzögerung
            RadioButtonFM.Checked = True
            Timer1.Interval = 250
        End If
    End Sub

    Private Sub VScrollBar1_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles VScrollBar1.ValueChanged, VScrollBar2.ValueChanged
        'Scan: Klappt auch mit Mausrad falls Fokus
        If VScrollBar1.Value < 50 Then SerialPort1.Write("6") 'UP
        If VScrollBar1.Value > 50 Then SerialPort1.Write("4") 'DOWN
        VScrollBar1.Value = 50
    End Sub

    Private Sub VScrollBar2_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles VScrollBar2.Scroll
        'Vol.: Klappt auch mit Mausrad falls Fokus
        If VScrollBar2.Value < 50 Then SerialPort1.Write("8") 'UP
        If VScrollBar2.Value > 50 Then SerialPort1.Write("2") 'DOWN
        VScrollBar1.Value = 50
    End Sub

    Private Sub RadioButtonWDR_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButtonWDR.Click
        SerialPort1.Write("W") ' Sender WDR
    End Sub

    Private Sub RadioButtonDLF_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButtonDLF.Click
        SerialPort1.Write("D") ' Sender DLF
    End Sub

    Private Sub RadioButtonFM_Click1(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButtonFM.Click
        SerialPort1.Write("F6") ' FM + ScanUP
    End Sub

    Private Sub RadioButtonSW_Click1(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButtonSW.Click
        SerialPort1.Write("K56") ' SW+5kHz-Schritte+ScanUP
    End Sub

    Private Sub RadioButtonMW_Click1(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButtonMW.Click
        SerialPort1.Write("M96") ' MW+9kHz+ScanUP
    End Sub

    Private Sub RadioButtonLW_Click1(ByVal sender As Object, ByVal e As System.EventArgs) Handles RadioButtonLW.Click
        SerialPort1.Write("L96") ' MW+9kHz+ScanUP
    End Sub
    Private Sub Anal(ByVal val As Double, ByVal max As Double)
        Dim r, phi, x, y ' Zeigergerätzeigertest für SNR
        r = 28 : phi = val / max * Math.PI / 2 - 3 * Math.PI / 4
        x = Needle.X2 + r * Math.Cos(phi)
        y = Needle.Y2 + r * Math.Sin(phi)
        Needle.X1 = x
        Needle.Y1 = y
    End Sub
End Class
